package com.tanpu.community.controller;

import com.tanpu.common.api.CommonResp;
import com.tanpu.community.api.beans.qo.FollowQo;
import com.tanpu.community.api.beans.req.HomePageReq;
import com.tanpu.community.api.beans.req.homepage.AddIdolReq;
import com.tanpu.community.manager.HomePageManager;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@Slf4j
@RequestMapping(value = "/api/homepage")

public class HomePageController {



    @Autowired
    private HomePageManager homePageManager;

    @PostMapping(value = "/editUserInfo")
    @ApiModelProperty("编辑个人资料")
    @ResponseBody
    public CommonResp<String> editUserInfo(@Validated @RequestBody HomePageReq req){
        String userId="liujm";
        homePageManager.editUserInfo(req,userId);
        return CommonResp.success("修改成功");
    }

    @GetMapping(value = "/queryMyFans")
    @ApiOperation("查询自己的粉丝")
    @ResponseBody
    public CommonResp<List<FollowQo>> queryMyFans() {
        String userId = "123";
        List<FollowQo> data = homePageManager.queryFansByIdolId(userId);
        homePageManager.judgeFollowed(data,userId);
        return CommonResp.success(data);
    }

    @GetMapping(value = "/queryFansByUserId")
    @ApiOperation("查询他人的粉丝")
    @ResponseBody
    public CommonResp<List<FollowQo>> queryFans(@RequestParam String targetUser) {
        String userId="123";
        List<FollowQo> data = homePageManager.queryFansByIdolId(targetUser);
        homePageManager.judgeFollowed(data,userId);
        return CommonResp.success(data);
    }

    @GetMapping(value = "/queryMyIdols")
    @ApiOperation("查询自己的关注")
    @ResponseBody
    public CommonResp<List<FollowQo>> queryMyIdols() {
        String userId = "123";
        List<FollowQo> data = homePageManager.queryIdolsByFollowerId(userId);
        homePageManager.judgeFollowed(data,userId);
        return CommonResp.success(data);
    }


    @GetMapping(value = "/queryIdolsByUserId")
    @ApiOperation("查询他人的关注")
    @ResponseBody
    public CommonResp queryIdols(@RequestParam String targetUser) {
        String userId="123";
        List<FollowQo> data = homePageManager.queryIdolsByFollowerId(targetUser);
        homePageManager.judgeFollowed(data,userId);
        return CommonResp.success(data);
    }

    @PostMapping(value = "/addIdol")
    @ApiOperation("关注他人")
    @ResponseBody
    public CommonResp addIdol(@RequestBody AddIdolReq req) {
        String userId = "123";
        homePageManager.addIdol(req.idolId, userId);
        return CommonResp.success();
    }

    @PostMapping(value = "/query/queryMyLike")
    @ApiOperation("我的点赞")
    @ResponseBody
    public CommonResp likeList(){
        String userId="123";
        return CommonResp.success();
    }

}
