package com.tanpu.community.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.tanpu.community.api.constants.BlockTypeEnum;
import com.tanpu.community.dao.entity.community.BlackListEntity;
import com.tanpu.community.dao.mapper.community.BlackListMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class BlackListService {
    @Resource
    private BlackListMapper blackListMapper;

    public void addBlock(String blockId, String userId, BlockTypeEnum type) {
        BlackListEntity blackListEntity = BlackListEntity.builder()
                .blocker(userId)
                .blockedId(blockId)
                .blockedType(type.getCode())
                .build();

        blackListMapper.insert(blackListEntity);
    }

    public BlackListEntity selectOne(String blocker, Integer blockType, String blockId) {
        return blackListMapper.selectOne(new LambdaQueryWrapper<BlackListEntity>()
                .eq(BlackListEntity::getBlocker, blocker)
                .eq(BlackListEntity::getBlockedId, blockId)
                .eq(BlackListEntity::getBlockedType, blockType));
    }

    public void removeBlackList(String blocker, String blockId, BlockTypeEnum blockType) {
        blackListMapper.delete(new LambdaQueryWrapper<BlackListEntity>()
                .eq(BlackListEntity::getBlocker, blocker)
                .eq(BlackListEntity::getBlockedId, blockId)
                .eq(BlackListEntity::getBlockedType, blockType.getCode()));
    }
}
